/*
 * OpenComal -- a free Comal implementation
 *
 * This file is part of the OpenComal package.
 * (c) Copyright 1992-2024 Jos Visser <josvisser66@gmail.com>
 *
 * The OpenComal package is covered by the GNU General Public
 * License. See doc/LICENSE for more information.
 */

/* OpenComal header file for OS dependent routines */

#define MAXUNSIGNED    ((unsigned)~0)

#include "pdcdsys.h"

#ifdef OS_MAC
#include "pdcmac.h"
#endif

#ifdef OS_LINUX
#include "pdclinux.h"
#endif

#ifdef OS_WIN32
#include "pdcwin32.h"
#endif

#ifdef OS_MSDOS
#include "pdcmsdos.h"
#endif

#ifdef __EMSCRIPTEN__
#include "pdcwasm.h"
#endif
